- **Viliam Furik**
(*https://www.mersenneforum.org/forumdisplay.php?f=174*)

- - **What might really happen if P=NP?**
(*https://www.mersenneforum.org/showthread.php?t=26855*)

1 Attachment(s)
Replying to the topic title, if you can prove P=NP, then getting the million bucks is the smallest and least important thing that will happen to you in the next 20 years.
Replying to the most recent discussion, does that mean you have an algorithm that solves generalized sudoku without guessing (i.e. without backtrack)? If so, I would really die to know it, haha. Or sell my soul to the devil, if not sold already, but I believe he won't want it, it would not be a good business for him. Mind that I consider myself a very strong sudoku solver, say top 0.01% world solvers. But I will wait for the official paper to read about that :razz: Good luck. Anyhow, as a way to go forward for your team, you could try to transform your algorithm to solve hamiltonian cycle or 3-sat, and I believe there are algorithms on the web to transform generalized sudoku into one of these or viceversa. Telling people about sudoku, they are reticent. Tell them about graphs and boolean circuits, you got them by the ears. Funny fact: I used to strongly believe that P=NP too, and many times I got into arguments with my professors because of it. I still believe it, but not so strong anymore. Now it is more like a "hope" :razz:. Some of my professors, those who had an opinion (mostly didn't dare to risk it, and preferred to stay at the fact side), believed the contrary, because "otherwise, anybody will be a Mozart". If we would be able to find solutions to problems with about the same speed we can verify that a given solution is right, then writing a symphony, or more thematic, proving a lot of math theory and physics phenomenon, would not take much longer than listening and appreciating the beauty of that same symphony or proof. I was thinking for a while that only our stupidity (i.e. we do not have yet the right algorithms, our current stage of evolution is not high enough, whatever) impede anybody to be a Mozart. I still believe that, by the way, and this has not much to do with P or NP. My way to "prove P=NP" was for a while (read: few years spent in uni and after) related to perfect graphs. These perfect graphs have nice colorability properties, i.e. most coloration problems are polynomial. And every NP-complete problem can be reduced to a graph problem, and as every graph problem can be reduced to a coloration problem in a graph, and as all graphs with few exceptions are perfect graphs (at the time this was called "Berge conjecture", it was later proved and became the [URL="https://en.wikipedia.org/wiki/Strong_perfect_graph_theorem"]Strong Perfect Graph's Theorem[/URL]), you see the consequence. It follows that all NP-complete problems are polynomial with few exceptions, but for the exceptions (non-Berge graphs) the coloring is trivial (i.e. hamiltonian cycle in an odd cycle graph is just the cycle itself, and in its complementary there is a simple linear algorithm to find it). The most of these "inclusions" are already proved, and I still believe that the way to go for showing P=NP is through perfect graphs and coloration. But few things were shaking my belief since that time, one of these few things was reading the SPG proof :lol: when it came out. Another was reading (some years ago) about the fact that generalized sudoku is NP-complete :razz:. Because I can't imagine how somebody will solve a well made sudoku grid without backtracking. If you don't believe me, try this grid, without guessing. Courtesy of Mark and Simon, from Cracking the Cryptic youtube channel (google them, it is fun!). This grid is trivial to solve by guessing, but almost impossible to solve by logic, as they proved in two videos. Then think about a 169x169 grid (with 13x13 biscuits) and tell my how would you solve THAT one in O(n^6) :shock: You can have few hundreds of chains, every one of them with a hundred links, and you will have to make few hundred guesses, fill each chain, and if the guess was wrong and you got a contradiction, you will need to backtrack and refill with the correct chain. I don't see other way. But again, I may be too stupid to be a Mozart, haha :lol: [ATTACH]25315[/ATTACH] |

[QUOTE=LaurV;583641]
Anyhow, as a way to go forward for your team, you could try to transform your algorithm to solve hamiltonian cycle or 3-sat, and I believe there are algorithms on the web to transform generalized sudoku into one of these or viceversa. Telling people about sudoku, they are reticent. Tell them about graphs and boolean circuits, you got them by the ears. [/QUOTE] I tried that. It didn't pan out so far. There is almost a trivial relation to the Latin squares, but the rest is not as easy to do. [QUOTE=LaurV;583641] If you don't believe me, try this grid, without guessing. Courtesy of Mark and Simon, from Cracking the Cryptic youtube channel (google them, it is fun!). This grid is trivial to solve by guessing, but almost impossible to solve by logic, as they proved in two videos. Then think about a 169x169 grid (with 13x13 biscuits) and tell my how would you solve THAT one in O(n^6) :shock: You can have few hundreds of chains, every one of them with a hundred links, and you will have to make few hundred guesses, fill each chain, and if the guess was wrong and you got a contradiction, you will need to backtrack and refill with the correct chain. I don't see other way. But again, I may be too stupid to be a Mozart, haha :lol:[/QUOTE] I know them, great channel indeed! I'll send you more details on inner working of the algorithm in PM (as well as the results of the experiment), but this I will say "publicly": I should be able to get a solution in O(n^12) - unless I found a counterexample to the algorithm. In O(n^6), I should be able to tell you whether it's uniquely solvable, non-uniquely solvable, or non-solvable. The part about being able to distinguish between unique solutions and non-unique ones is not well-studied yet. It's only simple observation. [STRIKE]But the same observation tells me, that if it is uniquely solvable, I should be able to get a solution in O(n^6).[/STRIKE] EDIT: After running the experiment, I found that at least for the present version of the algorithm, the striken is not true. |

[QUOTE=LaurV;583641]
[ATTACH]25315[/ATTACH][/QUOTE] Thanks, my 77-year old, sudoku-addicted mother will love it :cool: |

1 Attachment(s)
[QUOTE=Till;583694]Thanks, my 77-year old, sudoku-addicted mother will love it :cool:[/QUOTE]
You can google some n=4 grids for her, that's an even bigger challenge. I attached one such grid. |

[QUOTE=Viliam Furik;583623]That's possible, but I doubt the script runs in polynomial time.
Yes, they did. But none of them produced a general polynomial-time algorithm, as Wikipedia still states the problem is NP-complete.[/QUOTE] Definitely no poly time script on a classical (binary) system that I'm aware of but there are some good solvers out there. |

[QUOTE=jwaltos;583704]Definitely no poly time script on a classical (binary) system that I'm aware of but there are some good solvers out there.[/QUOTE]
That's true. |

All times are UTC. The time now is 01:52. |

Powered by vBulletin® Version 3.8.11

Copyright ©2000 - 2021, Jelsoft Enterprises Ltd.